<template>
  <Page title='Sign In'>
  <form novalidate="true" @submit.prevent="handleLogin">
    <div class="relative w-full mb-3">
      <label
        class="block uppercase text-gray-700 text-xs font-bold mb-2"
        for="grid-password"
        >Email</label
      ><input
        v-model="email"
        type="email"
        class="
          border-0
          px-3
          py-3
          placeholder-gray-400
          text-gray-700
          bg-white
          rounded
          text-sm
          shadow
          focus:outline-none
          focus:ring
          w-full
        "
        placeholder="Email"
        style="transition: all 0.15s ease 0s"
        required
      />
    </div>
    <div class="relative w-full mb-3">
      <label
        class="block uppercase text-gray-700 text-xs font-bold mb-2"
        for="grid-password"
        >Password</label
      ><input
        v-model="password"
        type="password"
        class="
          border-0
          px-3
          py-3
          placeholder-gray-400
          text-gray-700
          bg-white
          rounded
          text-sm
          shadow
          focus:outline-none
          focus:ring
          w-full
        "
        placeholder="Password"
        style="transition: all 0.15s ease 0s"
        required
      />
    </div>
                        <div v-if="errors.length" class="bg-red-700 mt-6 rounded px-6 py-3 text-white">
                      <p >
    <b>Please, correct to continue:</b>
    <ul>
      <li v-for="error in errors" v-bind:key=error> - {{ error }}</li>
    </ul>
  </p>
  </div>

    <div class="text-center mt-6 flex items-center justify-between">
      <button
        class="
          bg-white
          text-gray-700
          active:bg-gray-700
          text-sm
          font-bold
          uppercase
          px-6
          py-3
          rounded
          shadow
          hover:shadow-lg
          outline-none
          focus:outline-none
          mr-1
          mb-1
          w-full
        "
        style="transition: all 0.15s ease 0s"
        type="button"
        @click="handleClear"
      >
        Clear
      </button>
      <button
        class="
          bg-gray-900
          text-white
          active:bg-gray-700
          text-sm
          font-bold
          uppercase
          px-6
          py-3
          rounded
          shadow
          hover:shadow-lg
          outline-none
          focus:outline-none
          mr-1
          mb-1
          w-full
        "
        type="submit"
        style="transition: all 0.15s ease 0s"
      >
        Sign In
      </button>
    </div>
  </form>
                <hr class="mt-6 border-b-1 border-gray-400" />
                <div class="text-gray-500 text-center mb-3 font-bold">
                    <small>Not an user yet? So <nuxt-link to="/sign-up">sign up now!</nuxt-link></small>
                  </div>
                
  </Page>
</template>

<script>
export default {
  data() {
    return {
      email: '',
      password: '',
      errors: []
    }
  },
  methods: {
    async handleLogin() {
    try {
      await this.$axios.$post('http://localhost:8080/login', {
        email: this.email,
        password: this.password
     }).then(response => {
        const id = JSON.parse(atob(response.accessToken.split('.')[1]));
        this.$store.commit('saveInfo', { email: this.email, password: this.password, accessToken: response.accessToken, id: id.sub });
        this.$router.push(`users/${id.sub}`);
      })
    } catch(e) {
    this.errors.push(`${e.response.data}, please try again!`)
    }
    },
    handleClear(){
    this.email = "";
    this.password = ""
    }
  }
}
</script>
